﻿Type=StaticCode
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Process_Globals
	Private sql As SQL
	'Private lock As ReadWriteLock
End Sub

Public Sub Init
	
	Dim user As String = "your user"
	Dim PW As String =  "your password"
	Dim myDB As String = "keystore"
	Dim serverPort As String = "myserver-server.com:3306"
	
	sql.Initialize("com.mysql.jdbc.Driver",  _
			 $"jdbc:mysql://${serverPort}/${myDB}?"$ & _
			 $"user=${user}&password=${PW}"$)
	
	CreateDatabase
End Sub

Private Sub CreateDatabase
		
		Log("This needs to be done by hand now as MySQL needs special permissions set on user and DB")
		
		
		'--- Create a database named keystore
		'--- create a table named data 
'				CREATE TABLE `data`  (
'							id INT(6) UNSIGNED AUTO_INCREMENT PRIMARY KEY,
'							user VARCHAR(254) Not Null,
'							`key` VARCHAR(254) Not Null,
'							value BLOB,
'							time INT(6),
'							catalog_key VARCHAR(254)	);
'							
							
		'Dim s2 As String = $"CREATE INDEX If Not EXISTS id_index ON `data` (user);"$
		'Dim s3 As String = $"CREATE INDEX If Not EXISTS catalog_index ON `data` (catalog_key);"$
	
End Sub

Public Sub AddItem(item As Item)
	Dim subName As String = "AddItem"
	
	Try
		
		Dim lastId As String = sql.ExecQuerySingleResult2("SELECT max(id) FROM data WHERE user = ?", Array(item.UserField))
		If lastId = Null Then lastId = 0
		Dim id As Long = lastId + 1
		
		If item.TimeField < DateTime.Now - 3 * DateTime.TicksPerMinute Then
			Log("checking old record")
			
			'--- this is an old record. Maybe there is a newer one...
			Dim rs As ResultSet = sql.ExecQuery2("SELECT `the_time`, `value` FROM data WHERE user = ? AND key = ?", Array(item.UserField, item.KeyField))
			If rs.NextRow Then
				Dim currentTime As Long = rs.GetLong("the_time")
				If currentTime > item.TimeField Then
					Log("Old record discarded.")
					item.ValueField = rs.GetBlob("value")
					item.TimeField = currentTime
				End If
			End If
			rs.Close
		End If
		
		'--- mysql kill the old, insert the new
		Dim s1 As String = $"DELETE FROM data WHERE  `key` = "${item.KeyField}" and `user` = "${item.UserField}""$
		Log(s1)
		sql.ExecNonQuery(s1)
		
'		Log("******************************************************")
'		Log("Items time field: " & item.TimeField)
'		Log("Date time now: " & DateTime.now)
'		Dim ll As Long = Min(item.TimeField, DateTime.Now)
'		Log("Get the min value: " & ll)
'		Log("******************************************************")

		Dim MinTime As Long = MyMin(item.TimeField, DateTime.Now)
		Dim s3 As String = $"INSERT INTO data ( `user`, `key`, `value`, `id`,`the_time`) 
			VALUES ("${item.UserField}","${item.KeyField}","${item.ValueField}",${id},${MinTime})"$
		Log(s3)
		sql.ExecNonQuery(s3)
		
	Catch
		Log($"${subName}:  ${LastException}"$)
	End Try
End Sub

private Sub MyMin(t1 As Long, t2 As Long) As Long
	'--- b4j returns a double, not good for mysql
	Dim retMe As Long = Min(t1,t2)
	Log(retMe)
	Return retMe
End Sub



Public Sub GetUserItems (user As String, lastId As Int) As List
	Dim subName As String = "GetUserItems"
	Try
			
		Dim items As List
		items.Initialize
		Dim rs As ResultSet = sql.ExecQuery2("SELECT key, value, id, the_time FROM data WHERE user = ? AND id > ?", Array(user, lastId))
		Do While rs.NextRow
			Dim item As Item
			item.Initialize
			item.UserField = user
			item.KeyField = rs.GetString("key")
			item.ValueField = rs.GetBlob("value")
			item.idField = rs.GetLong("id")
			item.TimeField = rs.GetLong("the_time")
			items.Add(item)
		Loop
		rs.Close
		Return items
		
	Catch
		Log($"${subName}:  ${LastException}"$)
	End Try
	Return Null
	
End Sub


Public Sub DeleteUser(user As String)
	Dim subName As String = "DeleteUser"
	Try
		sql.ExecNonQuery2("DELETE FROM data WHERE user = ?", Array(user))
	Catch
		Log($"${subName}:  ${LastException}"$)
	End Try
End Sub

